//   !hpf$ processors q(2, 3)
// 
//   !hpf$ template s(25, 20)
//   !hpf$ distribute s(block, cyclic(5)) onto q   ! boring cyclic !!
// 
//   real res(15, 10)
//   !hpf$ align res(i, j) with s(20 - j, i)
// 
//   !hpf$ processors p(3, 2)
// 
//   !hpf$ template t(50, 20)
//   !hpf$ distribute t(cyclic, block) onto p
// 
//   integer a(15, 20)
// 
//   !hpf$ align a(i, j) with t(5 + 2 * i, j)
// 
//   !hpf$ processors r(6)
// 
//   real b(20, 10)
//   !hpf$ distribute b(*, block) onto r
// 
//   integer i, j, k
// 
//   do i = 1, 15
//     do j = 1, 20
//       a(i, j) = i * j
//     end do
//   end do
// 
//   do j = 1, 20
//     do k = 1, 10
//       b(j, k) = 1.0 / (j + k)
//     end do
//   end do
// 
//   res = matmul(a, b)
// 
//   do i = 1, 15
//     print "(10f7.2)", res(i, :)
//   end do
// 
// end

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test10 {
  static SpmdEnv spmd;
  static Procs2 p,q;
  static Procs1 r;
  static BlockRange x,y,s1,t2;
  static CyclicRange s2,t1;
  static Range r1;
  static Array2ddF res, b;
  static Array2ddI a;
  static Range i,j;
  static Index ii,ij;

public static void main(String args){
	spmd = new SpmdEnv (argv);

	q = new Procs2(2,3);
	if(q.on()) {
		s1 = new BlockRange(25,q.dim(0));	
		s2 = new BlockCyclicRange(20,q.dim(1),5);
		x = s2.subrng(15,0);
		y = s1.subrng(10,18,-1);
		res = new Array2ddF(q,x,y);
	} q.no();

	p = new Procs2(3,2);
	if(p.on()) {
		t1 = new CyclicRange(50,p.dim(0));
		t2 = new BlockRange(20,p.dim(1));
		i  = t1.subrng(15,6,2); // i  = t1.subrng(15,5,2); ??
		j  = t2.subrng(20,0);
		a  = new Array2ddI(p,i,j);
		ii = new Index(i);
		ij = new Index(j);
		ii.dim().over();
		for (ii.begin(); ii.test(); ii.next()) {
			ij.dim().over();
			for(ij.begin(); ij.test(); ij.next()){
				a.dat()[a.pos(ii,ij)] = i.idx(ii) * j.idx(ij);
			}ij.dim().revo();
		}ii.dim().revo();
	} p.no();

	r = new Procs1(6);
	if(r.on()) {
		// r1 = new Range(20);
		r2 = new BlockRange(10);
		b  = new Array2cdF(r, 20,r2);
		iv = new Index(r2);
		for (iu = 0; iu < 20; iu++) {
			iv.dim().over();
			for(iv.begin(); iv.test(); iv.next()){
				r.dat()[r.pos(iu,iv)] = 1.0 / ((float) (iu + 1) * (float) (r2.idx(iv) + 1));
			}ij.dim().revo();
		}ii.dim().revo();
	} r.no();

	spmd.finalize();
}

}

int main(int argc, char* argv[]) {

  matmul(res, a, b) ;

  aprintf("%7.2f%*N", res, y.size()) ;

  AdlibFinalize() ;
}


